<?php
/*
 * Created For BZ9.com
 * Author: Dave
 * Copyright: BZ9.com
 * Licence: Commercial, See included licence file.
 */
if(!defined("APPLICATION_PATH")){ die("No DIRECT Access"); }

class urls
{

    private $Reg;
    private $data;

    public function __construct($Registry){
        $this->Reg = $Registry;
        $this->Reg->log->log("class_load","Urls Class");

        $route_methods = array("showall","edit","add","delete","group_autocomplete");
        $this->Reg->route->set_route("urls", $route_methods);
    }

    public function showall()
    {
        $this->Reg->user->valid(true);
        if($this->Reg->settings->Config("database_type") == "mysql")
        {
            $this->showall_mysql();
        }
        if($this->Reg->settings->Config("database_type") == "file")
        {
            $this->showall_file();
        }
        exit;
    }

    public function search()
    {
        $this->Reg->user->valid(true);
        if($this->Reg->settings->Config("database_type") == "mysql")
        {
            $this->search_mysql();
        }

        exit;
    }

    private function showall_mysql()
    {
        $this->Reg->user->valid(true);
        $sql = "UPDATE shortlinks SET status = 'Inactive' WHERE expire = 'Yes' AND expdate <= curdate()";
        $this->Reg->db->query($sql);

        $page = $this->Reg->security->get("page","post");
        $limit = $this->Reg->security->get("rows","post");
        $sidx = $this->Reg->security->get("sidx","post");
        $sord = $this->Reg->security->get("sord","post");

        $this->data['ops'] = array(
            'eq'=>'=', //equal
            'ne'=>'<>',//not equal
            'lt'=>'<', //less than
            'le'=>'<=',//less than or equal
            'gt'=>'>', //greater than
            'ge'=>'>=',//greater than or equal
            'bw'=>'LIKE', //begins with
            'bn'=>'NOT LIKE', //doesn't begin with
            'in'=>'LIKE', //is in
            'ni'=>'NOT LIKE', //is not in
            'ew'=>'LIKE', //ends with
            'en'=>'NOT LIKE', //doesn't end with
            'cn'=>'LIKE', // contains
            'nc'=>'NOT LIKE'  //doesn't contain
        );

        $where = "";
        $searchField = $this->Reg->security->get("searchField","post");
        $searchOper = $this->Reg->security->get("searchOper","post");
        $searchString = $this->Reg->security->get("searchString","post");
        $dosearch = $this->Reg->security->get("_search","post");
        if ($dosearch == 'true') {
            $where = $this->getWhereClause($searchField,$searchOper,$searchString);
        }

        $sql = "SELECT COUNT(*) AS count FROM shortlinks $where";
        $count = $this->Reg->db->get_var($sql);
        if( $count >0 ) {
            $total_pages = ceil($count/$limit);
        } else { $total_pages = 0; }

        if ($page > $total_pages)
            $page=$total_pages;

        $start = $limit*$page - $limit;

        $limit = mysql_real_escape_string($limit);
        $sord = mysql_real_escape_string($sord);

        $sql = "SELECT id,name,url,linktxt,cloaked,descr,status,hits,sdefault,r_group,expire,DATE_FORMAT(expdate, '%m/%d/%Y') AS expdate,r_301,stealth FROM shortlinks $where ORDER BY r_group,$sidx $sord LIMIT $start , $limit";
        if($result = $this->Reg->db->get_results($sql))
        {
            $responce = array();
            $responce['page'] = $page;
            $responce['total'] = $total_pages;
            $responce['records'] = $count;
            $i=0;

                foreach ( $result as $row )
                {
                    $shortlink = $this->Reg->settings->Config("site_url").":".$row->linktxt;
                    $r_group = $row->r_group;
                    if($r_group == ""){$r_group = "Ungrouped"; }

                    $responce['rows'][$i]['id']=$row->id;
                    $responce['rows'][$i]['cell']=array($row->name,$row->url,$row->linktxt,$row->cloaked,$row->stealth,$row->r_301,$row->expire,$row->expdate,$row->status,$row->hits,$row->sdefault,$r_group,$row->descr,$shortlink,$row->linktxt);
                    $i++;
                }
            echo json_encode($responce);
            exit;
        }
        $responce['rows'][0]['id']=0;
        $responce['rows'][0]['cell']=array('','Nothing Found','','','','','','','','','','','','','');
        echo json_encode($responce);
        exit;
    }

    private function showall_file()
    {
        $this->Reg->user->valid(true);
        $str = file_get_contents(APPLICATION_PATH."/data/url.txt");
        if($str != ""){
            $arr = @unserialize($str);

            if(is_array($arr))
            {
                $i=0;
                $responce['page'] = 1;
                $responce['total'] = 4;
                $responce['records'] = count($arr);
                foreach($arr as  $key => $row){
                    $shortlink = $this->Reg->settings->Config("site_url").":".$row['linktxt'];
                    $responce['rows'][$i]['id']=$key;
                    $responce['rows'][$i]['cell']=array($row['name'],$row['url'],$row['cloaked'],$row['linktxt'],$row['status'],$row['hits'],$row['default'],$row['descr'],$shortlink,$row['linktxt']);
                    $i++;
                }

                echo json_encode($responce);
            }
        }
    }


    public function edit()
    {
        $this->Reg->user->valid(true);
        $this->get_data(true,true);

        if($this->Reg->settings->Config("database_type") == "mysql")
        {
            $this->data['url'] = mysql_real_escape_string($this->data['url']);
            $this->data['linktxt'] = mysql_real_escape_string($this->data['linktxt']);
            $this->data['cloaked'] = mysql_real_escape_string($this->data['cloaked']);
            $this->data['name'] = mysql_real_escape_string($this->data['name']);
            $this->data['descr'] = mysql_real_escape_string($this->data['descr']);
            $this->data['status'] = mysql_real_escape_string($this->data['status']);
            $this->data['hits'] = mysql_real_escape_string($this->data['hits']);
            $this->data['default'] = mysql_real_escape_string($this->data['default']);
            $this->data['id'] = mysql_real_escape_string($this->data['id']);
            $this->data['r_group'] = mysql_real_escape_string($this->data['r_group']);
            $this->data['expire'] = mysql_real_escape_string($this->data['expire']);
            $this->data['expdate'] = mysql_real_escape_string($this->data['expdate']);
            $this->data['r_301'] = mysql_real_escape_string($this->data['r_301']);
            $this->data['stealth'] = mysql_real_escape_string($this->data['stealth']);

            $sql = "UPDATE shortlinks SET url ='".$this->data['url']."',
    linktxt = '".$this->data['linktxt']."',
    cloaked = '".$this->data['cloaked']."',
    name = '".$this->data['name']."',
    descr = '".$this->data['descr']."',
    status = '".$this->data['status']."',
    hits = '".$this->data['hits']."',
    sdefault = '".$this->data['default']."',
    r_group = '".$this->data['r_group']."',
    expire = '".$this->data['expire']."',
    expdate = '".$this->data['expdate']."',
    r_301 = '".$this->data['r_301']."',
    stealth = '".$this->data['stealth']."'
     WHERE id = ".$this->data['id']." LIMIT 1";

            $this->Reg->db->query($sql);
            if($this->Reg->db->is_error()) { echo "<b>Error</b><br />There was a problem updating the database."; }

            if($this->data['default'] == "Yes"){
                $sql = "UPDATE shortlinks SET sdefault = 'No' WHERE linktxt != '".$this->data['linktxt']."'";
                $this->Reg->db->query($sql);
            }
        }



        if($this->Reg->settings->Config("database_type") == "file")
        {
            $arr = array();
            $str = file_get_contents(APPLICATION_PATH."/data/url.txt");
            if($str != ""){
                $arr = @unserialize($str);
            }
            if(is_array($arr))
            {
                $url = $this->data['url'];
                $linktxt = $this->data['linktxt'];
                $cloaked = $this->data['cloaked'];
                $name = $this->data['name'];
                $descr = $this->data['descr'];
                $status = $this->data['status'];
                $default = $this->data['default'];
                $arr[$this->data['id']] = array(
                    'url' => "$url",
                    'linktxt' => "$linktxt",
                    'cloaked' => "$cloaked",
                    'name' => "$name",
                    'descr' => "$descr",
                    'status' => "$status",
                    'hits' => 0,
                    'default' => "$default"
                );

                if($this->data['default'] == "Yes"){
                    foreach($arr as $key => $row)
                    {
                        if($row['linktxt'] != $this->data['linktxt'])
                        {
                            $arr[$key]['default'] = "No";
                        }
                    }
                }

                $arr = serialize($arr);
                $fn= APPLICATION_PATH."/data/url.txt";
                $fh = fopen($fn, 'w');
                fwrite($fh, $arr);
                fclose($fh);
            }
        }
    }


    public function add()
    {
        $this->Reg->user->valid(true);
        $this->get_data(false,true);

        if($this->Reg->settings->Config("database_type") == "mysql")
        {
            $this->data['url'] = mysql_real_escape_string($this->data['url']);
            $this->data['linktxt'] = mysql_real_escape_string($this->data['linktxt']);
            $this->data['cloaked'] = mysql_real_escape_string($this->data['cloaked']);
            $this->data['name'] = mysql_real_escape_string($this->data['name']);
            $this->data['descr'] = mysql_real_escape_string($this->data['descr']);
            $this->data['status'] = mysql_real_escape_string($this->data['status']);
            $this->data['hits'] = mysql_real_escape_string($this->data['hits']);
            $this->data['default'] = mysql_real_escape_string($this->data['default']);
            $this->data['r_group'] = mysql_real_escape_string($this->data['r_group']);
            $this->data['expire'] = mysql_real_escape_string($this->data['expire']);
            $this->data['expdate'] = mysql_real_escape_string($this->data['expdate']);
            $this->data['r_301'] = mysql_real_escape_string($this->data['r_301']);
            $this->data['stealth'] = mysql_real_escape_string($this->data['stealth']);

            $sql = "INSERT INTO shortlinks (id,url,linktxt,cloaked,name,descr,status,hits,sdefault,r_group,expire,expdate,r_301,stealth) VALUES (null,'".$this->data['url']."','".$this->data['linktxt']."','".$this->data['cloaked']."','".$this->data['name']."','".$this->data['descr']."','".$this->data['status']."','".$this->data['hits']."','".$this->data['default']."','".$this->data['r_group']."','".$this->data['expire']."','".$this->data['expdate']."','".$this->data['r_301']."','".$this->data['stealth']."')";
            $this->Reg->db->query($sql);

            if($this->Reg->db->is_error()) { echo "<b>Error</b><br />There was a problem adding the new shortlink to the database."; }

            if($this->data['default'] == "Yes"){
                $sql = "UPDATE shortlinks SET sdefault = 'No' WHERE linktxt != '".$this->data['linktxt']."'";
                $this->Reg->db->query($sql);
            }
        }


        if($this->Reg->settings->Config("database_type") == "file")
        {
            $arr = array();
            $str = file_get_contents(APPLICATION_PATH."/data/url.txt");
            if($str != ""){
                $arr = @unserialize($str);
            }
            if(is_array($arr))
            {
                $url = $this->data['url'];
                $linktxt = $this->data['linktxt'];
                $cloaked = $this->data['cloaked'];
                $name = $this->data['name'];
                $descr = $this->data['descr'];
                $status = $this->data['status'];
                $default = $this->data['default'];
                if(count($arr) == 0){
                $arr[1] = array(
                    'url' => "$url",
                    'linktxt' => "$linktxt",
                    'cloaked' => "$cloaked",
                    'name' => "$name",
                    'descr' => "$descr",
                    'status' => "$status",
                    'hits' => 0,
                    'default' => "$default"
                );
                } else {
                    $arr[] = array(
                        'url' => "$url",
                        'linktxt' => "$linktxt",
                        'cloaked' => "$cloaked",
                        'name' => "$name",
                        'descr' => "$descr",
                        'status' => "$status",
                        'hits' => 0,
                        'default' => "$default"
                    );
                }

                if($this->data['default'] == "Yes"){
                    foreach($arr as $key => $row)
                    {
                        if($row['linktxt'] != $this->data['linktxt'])
                        {
                            $arr[$key]['default'] = "No";
                        }
                    }
                }

                $arr = serialize($arr);
                $fn= APPLICATION_PATH."/data/url.txt";
                $fh = fopen($fn, 'w');
                fwrite($fh, $arr);
                fclose($fh);
            }
        }
    }

    private function get_data($need_id = true,$dup_check = false)
    {
        if($need_id){
        $this->data['id'] = $this->Reg->security->get("id","post","int");
        }
        $this->data['name'] = $this->Reg->security->get("name","post");
        $this->data['url'] = $this->Reg->security->get("url","post","url");
        $this->data['linktxt'] = $this->Reg->security->get("linktxt","post");
        $this->data['cloaked'] = $this->Reg->security->get("cloaked","post");
        $this->data['status'] = $this->Reg->security->get("status","post");
        $this->data['hits'] = $this->Reg->security->get("hits","post","int");
        $this->data['descr'] = $this->Reg->security->get("descr","post");
        $this->data['default'] = $this->Reg->security->get("default","post");
        $this->data['r_group'] = $this->Reg->security->get("r_group","post");
        $this->data['expire'] = $this->Reg->security->get("expire","post");
        $this->data['expdate'] = $this->Reg->security->get("expdate","post");
        $this->data['r_301'] = $this->Reg->security->get("r_301","post");
        $this->data['stealth'] = $this->Reg->security->get("stealth","post");

        $this->data['descr'] = str_replace('&#34;','',$this->data['descr']);

        if($this->data['hits']== ""){$this->data['hits']= 0;}


        if($need_id){
            if(!$this->Reg->security->validate($this->data['id'],"match",'/^[0-9]+$/i'))
            {
                if($this->Reg->settings->Config("database_type") == "file")
                {
                    if($this->data['id'] == ""){$this->data['id'] = 0; }
                } else {
                $this->Reg->error->raise_error("general","Invalid Id","admin");
                }
            }
        }
        if(!$this->Reg->security->validate($this->data['name'],"match",'/^[0-9a-zA-Z _]{1,200}+$/i'))
        {
            $this->Reg->error->raise_error("general","Link Name can only contain alphanumeric characters along with _ and spaces and be less than 200 characters long.","admin");
        }
        if(!$this->Reg->security->validate($this->data['url'],"url"))
        {
            $this->Reg->error->raise_error("general","Invalid URL detected.","admin");
        }
        if(!$this->Reg->security->validate($this->data['linktxt'],"match",'/^[0-9a-zA-Z_]{1,100}+$/i'))
        {
            $this->Reg->error->raise_error("general","Link Text can only contain alphanumeric characters along with _ and be less than 100 characters long.","admin");
        }
        if(!$this->Reg->security->validate($this->data['cloaked'],"option","Yes:No"))
        {
            $this->Reg->error->raise_error("general","Invalid Cloaked entry","admin");
        }
        if($this->data['status'] != "Active" && $this->data['status'] != "Inactive")
        {
            $this->Reg->error->raise_error("general","There is a problem recognising the status","admin");
        }
        if(!$this->Reg->security->validate($this->data['hits'],"match",'/^[0-9]+$/i'))
        {
            $this->data['hits'] = 0;
        }
        $this->data['descr'] = strip_tags($this->data['descr']);
        if($this->data['default'] != "Yes" && $this->data['default'] != "No")
        {
            $this->Reg->error->raise_error("general","There is a problem recognising the default status","admin");
        }
        if($this->data['r_group'] != ""){
            if(!$this->Reg->security->validate($this->data['r_group'],"match",'/^[0-9a-zA-Z_]{0,100}+$/i'))
            {
                $this->Reg->error->raise_error("general","Group can only contain alphanumeric characters along with _ and be less than 100 characters long.","admin");
            }
        }
        if($this->data['r_group'] == "Ungrouped"){
           $this->data['r_group'] = "";
        }

        if($this->data['expire'] != "Yes" && $this->data['expire'] != "No")
        {
            $this->Reg->error->raise_error("general","There is a problem recognising the expire status","admin");
        }
        if(!$this->Reg->security->validate($this->data['expdate'],"date","m/d/Y"))
        {
            $this->Reg->error->raise_error("general","Invalid expiry date","admin");
        }
        $this->data['expdate'] = date("Y-m-d", strtotime($this->data['expdate']));

        if($this->data['r_301'] != "Yes" && $this->data['r_301'] != "No")
        {
            $this->Reg->error->raise_error("general","There is a problem recognising the 301 status","admin");
        }

        if($this->data['r_301'] == "Yes" && $this->data['cloaked'] == "Yes")
        {
            $this->Reg->error->raise_error("general","You can not set cloaked to be a 301 redirect","admin");
        }

        if($this->data['expire'] == "Yes" && $this->data['default'] == "Yes")
        {
            $this->Reg->error->raise_error("general","You can not set the default link to expire","admin");
        }
        if($this->data['stealth'] != ""){
            if(!$this->Reg->security->validate($this->data['stealth'],"url"))
            {
                $this->Reg->error->raise_error("general","Invalid Stealth URL detected.","admin");
            }
        }


        if($this->Reg->error->is_errors("general"))
        {
            $error_out = "<b>Error</b><br />";
            $error_out .= $this->Reg->error->get_general();
            echo $error_out;
            exit;
        }

        if($dup_check)
        {

            if($this->Reg->settings->Config("database_type") == "mysql")
            {
                $and = "";
                if($need_id){
                    $id = mysql_real_escape_string($this->data['id']);
                    $and = " AND id !=".$id;
                }
                $linktext = mysql_real_escape_string($this->data['linktxt']);
                $sql = "SELECT COUNT(*) AS count FROM shortlinks WHERE linktxt = '$linktext' $and";
                $count = $this->Reg->db->get_var($sql);
                if($count > 0)
                {
                    $this->Reg->error->raise_error("general","A link already exists with that Link ID.","admin");
                }
            }

            if($this->Reg->settings->Config("database_type") == "file")
            {
                $arr = array();
                $str = file_get_contents(APPLICATION_PATH."/data/url.txt");
                if($str != ""){
                    $arr = @unserialize($str);
                }
                if(is_array($arr))
                {
                    $i=1;
                    foreach($arr as $key => $row){
                        if($this->data['linktxt'] == $row['linktxt'])
                        {
                            if($need_id){
                                if($this->data['id'] != $i){
                                    $this->Reg->error->raise_error("general","A link already exists with that Link ID.","admin");
                                }
                            } else {
                                $this->Reg->error->raise_error("general","A link already exists with that Link ID.","admin");
                            }
                        }
                        $i++;
                    }
                }
            }


        }
        if($this->Reg->error->is_errors("general"))
        {
            $error_out = "<b>Error</b><br />";
            $error_out .= $this->Reg->error->get_general();
            echo $error_out;
            exit;
        }
    }

    public function delete()
    {
        $this->Reg->user->valid(true);
        $this->data['id'] = $this->data['id'] = $this->Reg->security->get("id","post","int");

        if(!$this->Reg->security->validate($this->data['id'],"match",'/^[0-9]+$/i'))
        {
            $this->Reg->error->raise_error("general","Invalid Id","admin");
        }

        if($this->Reg->error->is_errors("general"))
        {
            $error_out = "<b>Error</b><br />";
            $error_out .= $this->Reg->error->get_general();
            echo $error_out;
            exit;
        }


        if($this->Reg->settings->Config("database_type") == "mysql")
        {
            $this->data['id'] = mysql_real_escape_string($this->data['id']);
            $sql = "DELETE FROM shortlinks WHERE id = '".$this->data['id']."'";

            $this->Reg->db->query($sql);
            if($this->Reg->db->is_error()) { echo "<b>Error</b><br />There was a problem deleting this link."; }
        }


        if($this->Reg->settings->Config("database_type") == "file")
        {
            $arr = array();
            $str = file_get_contents(APPLICATION_PATH."/data/url.txt");
            if($str != ""){
                $arr = @unserialize($str);
            }
            if(is_array($arr))
            {
                unset($arr[$this->data['id']]);
                $arr = serialize($arr);
                $fn= APPLICATION_PATH."/data/url.txt";
                $fh = fopen($fn, 'w');
                fwrite($fh, $arr);
                fclose($fh);
            }
        }
    }

   private function getWhereClause($col, $oper, $val){
       if(!$this->Reg->security->validate($col,"match",'/^[0-9a-zA-Z_]{1,300}+$/i'))
       {
           return false;
       }
       if(!$this->Reg->security->validate($val,"match",'~^[0-9a-zA-Z_./]{1,300}+$~i'))
       {
           return false;
       }

        if($oper == 'bw' || $oper == 'bn') $val .= '%';
        if($oper == 'ew' || $oper == 'en' ) $val = '%'.$val;
        if($oper == 'cn' || $oper == 'nc' || $oper == 'in' || $oper == 'ni') $val = '%'.$val.'%';
       $col = mysql_real_escape_string($col);
       $val = mysql_real_escape_string($val);
       $match = " WHERE $col {$this->data['ops'][$oper]} '$val' ";
        return $match;
    }

    public function group_autocomplete()
    {
        $grp = array("Ungrouped");
        $sql = "SELECT DISTINCT(r_group) FROM shortlinks ORDER BY r_group ASC";
        if($result = $this->Reg->db->get_results($sql))
        {
            foreach($result as $row)
            {
                if($row->r_group != ""){
                array_push($grp,$row->r_group);
                }
            }
            echo json_encode($grp);
        }
        exit;
    }


}


